## 简介

精心设计的动画会让用户界面感觉更直观、流畅，能改善用户体验。 Flutter可以轻松实现各种动画类型，对于许多widget，特别是[Material Design widgets](https://flutter.io/docs/reference/widgets/material)，都带有在其设计规范中定义的标准动画效果(但也可以自定义这些效果)。本章将详细介绍Flutter的动画系统，并会通过几个小实例来演示，以帮助开发者迅速理解并掌握动画的开发流程与原理。

## 本章目录

* [9.1：Flutter动画简介](intro.md)
* [9.2：动画结构](animation_structure.md)
* [9.3：自定义路由过渡动画](route_transition.md) 
* [9.4：Hero动画](hero.md) 
* [9.5：交织动画](stagger_animation.md) 
* [9.6：通用"切换动画"组件（AnimatedSwitcher）](animated_switcher.md) 
* [9.7：动画过渡组件](animated_widgets.md) 
